Skip to main content
All docs
V25.2
  • Create a Vue Front-End Application with a Document Viewer

    • 4 minutes to read

    The Web Document Viewer is used in applications that contain client and server parts:

    Client
    A Web Document Viewer integrated in a client Vue application displays a report provided by the server-side model.
    Server
    The server is an ASP.NET Core application that handles client data requests and provides access to data sources, report storage, and other back-end capabilities.

    This tutorial creates and configures a client React application and a server ASP.NET Core backend. The client contains the Web Document Viewer control.

    View Example

    Prerequisites

    Note the following details about package versions:

    • The script version on the client should match the library version on the server.
    • DevExpress npm package versions should be identical.

    Server (Back-End) Application

    Use the DevExpress CLI Template

    You can use DevExpress CLI Templates to create an ASP.NET Core back-end application. Begin with the steps below:

    1. Install DevExpress ASP.NET Core project templates from nuget.org:

      dotnet new install DevExpress.AspNetCore.ProjectTemplates
      
    2. Create a back-end Reporting application for a Document Viewer:

      dotnet new dx.aspnetcore.reporting.backend -n ServerApp --add-designer false
      

      You can use the following parameters to see available command options: -? | -h | --help.

    3. Enable cross-origin requests (CORS). Specify the policy that allows any local application to access the report’s back-end. Use the SetIsOriginAllowed method to set it up.

      Call the UseCors method and pass the policy name as a parameter. The UseCors method should be called after the UseRouting method and before any MVC-related code. Place the UseCors method before the UseMvc or UseEndpoints methods.

      Open the application startup file and insert the following code:

      var builder = WebApplication.CreateBuilder(args);
      
      builder.Services.AddCors(options => {
          options.AddPolicy("AllowCorsPolicy", builder => {
              // Allow all ports on local host.
              builder.SetIsOriginAllowed(origin => new Uri(origin).Host == "localhost");
              builder.AllowAnyHeader();
              builder.AllowAnyMethod();
          });
      });
      
      var app = builder.Build();
      
      app.UseRouting();
      app.UseCors("AllowCorsPolicy");
      
      app.UseEndpoints(endpoints => {
          endpoints.MapControllerRoute(
              name: "default",
              pattern: "{controller=Home}/{action=Index}/{id?}");
      });
      
      app.Run();
      
    4. To run the server-side application, run the following command:

      cd ServerApp
      dotnet run
      

    Use Visual Studio Template

    To create a back-end application from a Microsoft or DevExpress Template in Visual Studio, review the following help topics:

    Client (Front-End) Application

    1. Create a Vue application with the default preset:

      npm create vue@latest vue-document-viewer
      
    2. Navigate to the project folder and install DevExpress npm packages:

      cd vue-document-viewer
      npm install devextreme@25.2-stable @devexpress/analytics-core@25.2-stable devexpress-reporting@25.2-stable
      
    3. Create a src/App.vue file with the following content:

      <template>
        <div ref="viewer" style="position: absolute; left: 0; right: 0; top: 0; bottom: 0"></div>
      </template>
      <script>
        import 'devexpress-reporting/dx-webdocumentviewer';
        import {DxReportViewer} from 'devexpress-reporting/dx-webdocumentviewer';
        import * as ko from 'knockout';
      
        export default {
          name: "WebDocumentViewer",
          mounted() {
            const reportUrl = ko.observable("TestReport");
            const viewerRef = this.$refs.viewer;
            const requestOptions = {
              host: " http://localhost:5000/",
              invokeAction: "DXXRDV"
            };
            const viewer = new DxReportViewer(viewerRef, {
              reportUrl,
              requestOptions
            });
            viewer.render();
          },
          beforeUnmount() {
            ko.cleanNode(this.$refs.viewer);
          }
        };
      </script>
      
    4. Add styles to the src/main.js file:

      import "devextreme/dist/css/dx.light.css";
      import "@devexpress/analytics-core/dist/css/dx-analytics.common.css";
      import "@devexpress/analytics-core/dist/css/dx-analytics.light.css";
      import "devexpress-reporting/dist/css/dx-webdocumentviewer.css";
      import { createApp } from 'vue'
      import App from './App.vue'
      
      createApp(App).mount('#app')
      
    5. Remove default project styles to avoid conflicts. To do this, remove the ./assets/main.css import in the main.js file.

    Run the Project

    1. Run the server application.

      Make sure to specify the correct server-side port (5000 in this example) and report name (TestReport in this example) in the Viewer.vue file.

    2. Run the client application:

      npm run dev
      
    3. Open your browser and navigate to the URL specified in the command output to see the result.

    Troubleshooting

    When you start the application, you may encounter the following issues:

    Page Is Blank

    The Document Viewer page is blank. The following error message is displayed at the bottom of the page:

    Could not open report ‘TestReport’

    Check the following:

    • The backend application is up and running.
    • The backend application runs on the port specified in the host setting of the Document Viewer component.
    • The application’s URI is compliant with the CORS policy specified in your back-end application.
    • The reportUrl setting value matches an existing report. For the backend application, ensure that either the Reports folder contains a reportUrl.repx file or the ReportsFactory.Reports dictionary contains the reportUrl entry (if the back-end application originated from the DevExpress template).
    • The version of DevExpress npm packages should match the version of NuGet packages. Enable Development Mode to check for a library version mismatch on every request to the server. For details, review the following help topic: Server-Side Libraries Version.

    Refer to the following topic for more information: Troubleshooting.

Skip to main content
A newer version of this page is available. .

Document Viewer Integration in React

  • 3 minutes to read

You can use the HTML5 Document Viewer in JavaScript with React based on the server-side model. You should create two projects: a server (backend) project and a client (frontend) part that includes all the necessary styles, scripts, and HTML-templates.

Important

Perform the steps from one of the following topics to prepare a backend application:

This document describes how to configure and host the client part:

  1. Create a new folder to store all the files related to the client-side functionality (for instance, name it ClientSide).
  2. Use Bower to download all the necessary client resources. Add the bower.json file in the created folder and add the following code to this file:

    {
      "name": "html5-document-viewer-example-react",
      "dependencies": {
        "xtrareportsjs": "~19.1.16",
        "react": "latest",
        "babel": "latest"
      }
    }
    

    Note

    Frontend and backend applications should use the same version of DevExpress controls.

  3. Open the console, navigate to your application folder and run the following command:

    bower install
    

    You can find all the libraries in the bower_components folder after installation is completed.

  4. Create a View file in the root folder (the index.html file in this example) and add links to Bower resources to the head section.

    <!DOCTYPE html>
    <html>
    
    <head>
        <title></title>
        <link href="~/bower_components/devextreme/css/dx.common.css" rel="stylesheet" />
        <link href="~/bower_components/devextreme/css/dx.light.css" rel="stylesheet" />
        <script src="~/bower_components/jquery/dist/jquery.js"></script>
        <script src="~/bower_components/knockout/dist/knockout.js"></script>
        <script src="~/bower_components/devextreme/js/dx.all.js"></script>
        <script src="~/bower_components/jquery-ui/jquery-ui.js"></script>
        <link href="~/bower_components/jquery-ui/themes/base/jquery-ui.min.css" rel="stylesheet" />
    
        <link href="~/bower_components/xtrareportsjs/css/dx-analytics.common.min.css" rel="stylesheet" />
        <link href="~/bower_components/xtrareportsjs/css/dx-analytics.light.min.css" rel="stylesheet" />
        <link href="~/bower_components/xtrareportsjs/css/dx-webdocumentviewer.min.css" rel="stylesheet" />
        <script src="~/bower_components/xtrareportsjs/js/dx-analytics-core.min.js"></script>
        <script src="~/bower_components/xtrareportsjs/js/dx-webdocumentviewer.min.js"></script>
    
        <script src="~/bower_components/react/react.development.js"></script>
        <script src="~/bower_components/react/react-dom.development.js"></script>
        <script src="~/bower_components/babel/browser.js"></script>
    </head>
    
    ...
    </html>
    

    Make sure that you meet all the requirements to deploy the control on the client. Refer to Document Viewer Requirements and Limitations for a complete client resource list.

    Note that this sample uses a script with a predefined localization dictionary.

  5. Add a JSX file (example.jsx) to provide data to the View.

    Create the ReportViewer and Root classes that extend the base React.Component class as shown below. Use the dxReportViewer binding to render the Document Viewer element.

    "use strict"
    const host = 'http://localhost:54114/';
    
    class ReportViewer extends React.Component {
        constructor(props) {
            super(props);
            this.reportUrl = ko.observable(props.reportUrl);
            this.requestOptions = {
                host,
                // Use this line if you use an ASP.NET MVC backend
                invokeAction: "WebDocumentViewer/Invoke"
                // Uncomment this line if you use an ASP.NET Core backend
                // invokeAction: "DXXRDV"
            };
        }
        render() {
            return (<div ref="viewer" data-bind="dxReportViewer: $data"></div>);
        }
        componentWillReceiveProps(newProps) {
            this.reportUrl(newProps.reportUrl);
        }
        componentDidMount() {
            ko.applyBindings({
                reportUrl: this.reportUrl,
                requestOptions: this.requestOptions
            }, this.refs.viewer);
        }
        componentWillUnmount() {
            ko.cleanNode(this.refs.viewer);
        }
    }
    
    class Root extends React.Component {
        constructor(props) {
            super(props);
            this.state = { value: "Products", reports: [] };
        }
    
        render() {
            return (<div style = {{width: "100%", height: "1000px"}}>
                <ReportViewer reportUrl={this.state.value} />
            </div>);
        }
    }
    
    ReactDOM.render(<Root />, document.getElementById("viewerhost"))
    
  6. Link the file created at the previous step in the index.html file:

    <!DOCTYPE html>
    <html>
    ... 
    
    <body>
        <div id="viewerhost"></div>
        <script type="text/babel" src="example.jsx"></script>
    </body>
    </html>
    
  7. Host your client-side part on the web server.

    For instance, start the Internet Information Services (IIS) Manager, right-click the Sites item in the Connections section and select Add Website. In the invoked dialog, specify the site name, the path to the folder with the client-side functionality and the website’s IP address.

    host-react-example-in-iis

  8. For this example to work correctly, you should first run a backend project in Visual Studio before running the client part.

Skip to main content

DevExpress v24.2 Update — Your Feedback Matters

Our What's New in v24.2 webpage includes product-specific surveys. Your response to our survey questions will help us measure product satisfaction for features released in this major update and help us refine our plans for our next major release.

Take the survey Not interested

Create an Angular Front-End Application with a Document Viewer

  • 6 minutes to read

The Web Document Viewer is used in applications that contain client and server parts:

Client
A Web Document Viewer integrated in a client Angular application displays a report provided by the server-side model.
Server
The server is an ASP.NET Core application that handles client data requests and provides access to data sources, report storage, and other back-end capabilities.

This tutorial creates and configures a client Angular application and a server ASP.NET Core backend. The client contains the Web Document Viewer control.

View Example

#Prerequisites

Note the following details about package versions:

  • The script version on the client should match the library version on the server.
  • DevExpress npm package versions should be identical.

#Server (Back-End) Application

#Use the DevExpress CLI Template

You can use DevExpress CLI Templates to create an ASP.NET Core back-end application. Begin with the steps below:

  1. Install DevExpress ASP.NET Core project templates from nuget.org:

    dotnet new install DevExpress.AspNetCore.ProjectTemplates
    
  2. Create a back-end Reporting application for a Document Viewer:

    console
    dotnet new dx.aspnetcore.reporting.backend -n ServerApp --add-designer false
    

    You can use the following parameters to see available command options: -? | -h | --help.

  3. Enable cross-origin requests (CORS). Specify the policy that allows any local application to access the report’s back-end. Use the SetIsOriginAllowed method to set it up.

    Call the UseCors method and pass the policy name as a parameter. The UseCors method should be called after the UseRouting method and before any MVC-related code. Place the UseCors method before the UseMvc or UseEndpoints methods.

    Open the application startup file and insert the following code:

    var builder = WebApplication.CreateBuilder(args);
    
    builder.Services.AddCors(options => {
        options.AddPolicy("AllowCorsPolicy", builder => {
            // Allow all ports on local host.
            builder.SetIsOriginAllowed(origin => new Uri(origin).Host == "localhost");
            builder.AllowAnyHeader();
            builder.AllowAnyMethod();
        });
    });
    
    var app = builder.Build();
    
    app.UseRouting();
    app.UseCors("AllowCorsPolicy");
    
    app.UseEndpoints(endpoints => {
        endpoints.MapControllerRoute(
            name: "default",
            pattern: "{controller=Home}/{action=Index}/{id?}");
    });
    
    app.Run();
    
  4. To run the server-side application, run the following command:

    console
    cd ServerApp
    dotnet run
    

#Use Visual Studio Template

To create a back-end application from a Microsoft or DevExpress Template in Visual Studio, review the following help topics:

#Client (Front-End) Application

Follow the steps below to create and configure the client part:

  1. Make sure you have the current Node.js version with npm installed on your machine.

    console
    node -v
    npm -v
    
  2. Open the console window and install the Angular CLI v17+ globally.

    console
    npm install -g @angular/cli
    

    When prompted for options, select default settings (press Enter).

  3. Run the command to create a new Angular project:

    console
    ng new angular-document-viewer
    

    Refer to the Angular documentation for information on the Angular application structure.

  4. Install the following packages:

    console
    cd angular-document-viewer
    npm install devextreme@24.2-stable devextreme-angular@24.2-stable @devexpress/analytics-core@24.2-stable devexpress-reporting-angular@24.2-stable
    

    Note

    Front-end and back-end applications should use the same version of DevExpress controls.

  5. Replace the content of the src\app\app.component.ts file with the following code:

    import { Component, ViewEncapsulation } from '@angular/core';
    import { CommonModule } from '@angular/common';
    import { RouterOutlet } from '@angular/router';
    import { DxReportViewerModule } from 'devexpress-reporting-angular';
    
    
    @Component({
      selector: 'app-root',
      encapsulation: ViewEncapsulation.None,
      standalone: true,
      imports: [
      CommonModule, 
      RouterOutlet,
      DxReportViewerModule
      ],
      templateUrl: './app.component.html',
      styleUrls: [
        "../../node_modules/devextreme/dist/css/dx.light.css",
        "../../node_modules/@devexpress/analytics-core/dist/css/dx-analytics.common.css",
        "../../node_modules/@devexpress/analytics-core/dist/css/dx-analytics.light.css",
        "../../node_modules/devexpress-reporting/dist/css/dx-webdocumentviewer.css"
      ]
    })
    export class AppComponent {
        title = 'DXReportViewerSample';
        reportUrl: string = 'TestReport';
        hostUrl: string = 'http://localhost:5000/';
        // Use this line if you use an ASP.NET MVC backend
        //invokeAction: string = "/WebDocumentViewer/Invoke";
        // Use this line if you use an ASP.NET Core backend
        invokeAction: string = '/DXXRDV';
    
    }
    

    For more information on component options, review the following help topic: Document Viewer Client-Side Configuration in an Angular Application.

  6. Replace the content of the src\app\app.component.html file with the following code to add dx-report-viewer Angular component:

    <dx-report-viewer [reportUrl]="reportUrl" height="800px">
    <dxrv-request-options [invokeAction]="invokeAction" [host]="hostUrl"></dxrv-request-options>
    </dx-report-viewer>
    

#Run the Project

  1. Run the server application.

    Make sure to specify the correct server-side port (5000 in this example) and report name (TestReport in this example) in the src\app\app.component.ts file.

  2. Run the client application:

    cmd
    npm start
    

    Note

    For recent Angular versions (16 and later) you may have to compile the Angular project with the skipLibCheck option set to true, and increase the initial budget setting in the angular.json file up to 5mb to avoid compilation errors.

  3. Open the http://localhost:4200/ location in the browser to see the result.

    Web Document Viewer Page

#Troubleshooting

When you start the application, you may encounter the following problems:

#Page Is Blank

The Document Viewer page is blank. The following error message is displayed at the bottom of the page:

Could not open report ‘TestReport’

Check the following:

  • The backend application is up and running.
  • The backend application runs on the port specified in the host setting of the Document Viewer component.
  • The application’s URI is compliant with the CORS policy specified in your back-end application.
  • The reportUrl setting value matches an existing report. For the backend application, ensure that either the Reports folder contains a reportUrl.repx file or the ReportsFactory.Reports dictionary contains the reportUrl entry (if the back-end application originated from the DevExpress template).
  • The version of DevExpress npm packages should match the version of NuGet packages. Enable Development Mode to check for a library version mismatch on every request to the server. For details, review the following help topic: Server-Side Libraries Version.

Refer to the following topic for more information: Troubleshooting.

For information on how to identify the cause of an issue, refer to the following topic: Reporting Application Diagnostics.

#What’s Next

Now that you’ve created a basic Angular app with a Document Viewer, you can continue to extend your application with the following features:

Client-Side Configuration
Integrate the Document Viewer for Web into your Angular-based application.
Specify Parameter Values
Set parameter values in the Document Viewer
Customize Toolbar and Tab Panel
Customize available Document Viewer elements.
See Also